package cn.ecpark.service.usergw.utils;

import static org.junit.Assert.assertTrue;

import org.apache.dubbo.config.ReferenceConfig;
import org.apache.dubbo.rpc.service.GenericService;
import org.junit.Assert;
import org.junit.Test;

import cn.ecpark.service.usergw.utils.Extract.GenericServiceBase;


public class TestExtract {

    @Test
    public void TestParseDubboUri() {
        GenericServiceBase gsb;
        gsb = Extract.GenericServiceBase.Parse("dubbo://application/test/com.a.b:1.0.0");
        Assert.assertNotNull("is Null", gsb);
        Assert.assertEquals(gsb.getApplication(), "application");
        Assert.assertEquals(gsb.getGroup(), "test");
        Assert.assertEquals(gsb.getInterface(), "com.a.b");
        Assert.assertEquals(gsb.getVersion(), "1.0.0");

        gsb = Extract.GenericServiceBase.Parse("dubbo://application/com.a.b:1.0.0");
        Assert.assertNotNull("is Null", gsb);
        Assert.assertEquals(gsb.getApplication(), "application");
        Assert.assertEquals(gsb.getInterface(), "com.a.b");
        Assert.assertEquals(gsb.getVersion(), "1.0.0");
    }

    @Test
    public void TestFirst2Case() {
        String content = Convert.firstUpperCase("str");
        Assert.assertEquals(content, "Str");
    }


    @Test
    public void TestReferenceConfigKey() {
        ReferenceConfig<GenericService> ref = new ReferenceConfig<GenericService>();
        try {
            Extract.getReferenceConfigKey(ref);
            Assert.assertTrue(false);
        } catch (Exception e) {
            String m = e.getMessage();
            assertTrue(m.startsWith("No interface info in ReferenceConfig"));
        }
    }
}